// Author 		: F. de la Parra
// Date			: March, 2019
// Version		: 1.0

// Class replacing T must implement the 'Comparable' interface.
public class Comparison<T extends Comparable> {
	
	private T item1;
	private T item2;
	
	// Default constructor.
	public Comparison() {
		item1 = null;
		item2 = null;
	}
	
	// Full parameter constructor.
	public Comparison(T newItem1, T newItem2) {
		item1 = newItem1;
		item2 = newItem2;
	}
	
	// Accessor methods.
	
	public T getItem1() {
		return item1;
	}
	
	public T getItem2() {
		return item2;
	}
	
	// Mutator methods.
	
	public void setItem1(T newItem1) {
		item1 = newItem1;
	}

	public void setItem2(T newItem2) {
		item2 = newItem2;
	}
	
	// BEHAVIOUR METHODS
	
	// Basic methods.
	
	public String toString() {
		if (item1 != null && item2 != null) 
			return "\nitem1 is:\n" + item1.toString() + "\n" +
				   "\nitem2 is:\n" + item2.toString();
		else
			return "One or both T objects are null!";
	}
	
	// Other methods.
	
	// Compare for equality two objects of type T
	public int compareEqual(T item1, T item2) {
		if (item1 == null || item2 == null)
			return -1;
		else if (item1 == item2) 
			return 0;
		return 1;
	}

	// Compare for proper ordering of two objects of type T.
	// We enforce the implementation of the 'Comparable' interface
	// in the classes passed as a T parameter to this class. We use
	// the compareTo method of the parameter class T.
	public int compareOrder(T item1, T item2) {
		if (item1 == null || item2 == null)
			return -9;
		return item1.compareTo(item2);
	}
}